/* wegina wexx -- a rexx interpreter which doesn't use a console window
 * under NT
 * Copyright 2001, Patrick TJ McPhee
 * Released under the Mozilla Public licence
 * The original code is wegina
 * The original author is Patrick McPhee
 * Contributors:
 *
 * $Header: C:/ptjm/rexx/wegina/RCS/wegina.c 1.6 2003/03/31 01:09:35 ptjm Rel $
 */

#include <windows.h>
#define INCL_REXXSAA
#include <rexxsaa.h>
#include <string.h>
#include <stdio.h>


/* put stuff in a message box */
static LONG APIENTRY ptjMsgBox (LONG exit, LONG subfunc, PEXIT parms)
{
    RXFNCCAL_PARM * plist = parms;
    EXIT * prms = parms;

    switch (subfunc) {
       case RXSIOSAY:
          say(prms[0].siosay.rxsio_string.strptr, prms[0].siosay.rxsio_string.strlength);
          return RXEXIT_HANDLED;
          break;
       case RXSIOTRC:
          saytrace(prms[0].siosay.rxsio_string.strptr, prms[0].siosay.rxsio_string.strlength);
          return RXEXIT_HANDLED;
          break;
       case RXSIOTRD:
          prms[0].siotrd.rxsiotrd_retc.strlength = RXAUTOBUFLEN;
          pull(prms[0].siotrd.rxsiotrd_retc.strptr, &prms[0].siotrd.rxsiotrd_retc.strlength);
          return RXEXIT_HANDLED;
          break;
       case RXSIODTR:
          prms[0].siotrd.rxsiotrd_retc.strlength = RXAUTOBUFLEN;
          pulltrace(prms[0].siotrd.rxsiotrd_retc.strptr, &prms[0].siotrd.rxsiotrd_retc.strlength);
          return RXEXIT_HANDLED;
          break;
    }

    return RXEXIT_NOT_HANDLED;
}


int
WINAPI
WinMain(HINSTANCE hInst, HINSTANCE prev, LPSTR cmdline, int show)
{
   RXSTRING args;
   char * macfile;
   int rc;
   short src;
   static const char whitespace[] = " \t\n\r\v\f";
   RXSYSEXIT exits[2];

   /* first thing on cmdline is the name of this program.
    * second thing is the macro file */

   /* skip leading whitespace */
   macfile = cmdline + strspn(cmdline, whitespace);

   /* get out if there is no argument */
   if (macfile[0] == 0) {
      return -1;
   }

   /* the argument list starts after the macro file */
   args.strptr = macfile + strcspn(macfile, whitespace);

   if (*args.strptr) {
      /* null terminate the macro file name */
      *(args.strptr++) = 0;
   
      /* and skip intervening whitespace */
      args.strptr += strspn(args.strptr, whitespace);
      args.strlength = strlen(args.strptr);
   }
   else {
      args.strlength = 0;
      args.strptr = NULL;
   }

   RexxRegisterExitExe("msgbox", ptjMsgBox, NULL);

   exits[0].sysexit_name = "msgbox";
   exits[0].sysexit_code = RXSIO;
   exits[1].sysexit_name = NULL;
   exits[1].sysexit_code = RXENDLST;


   rc = RexxStart(1, &args, macfile, NULL, "SYSTEM", RXCOMMAND, exits, &src, NULL);

   wait_for_say();


   if (!rc)
      return src;
   else
      return rc;
}
